;=======================================================
#label GetStringID32NoCase()_3 = 0x004215B0, 0x00421550, 0x00421720, 0x00421980
;=======================================================
ID32 GetStringID32NoCase(
 LPSTRING lpString,
 UNKNOWN Param2,
 INT Param3
); 

a.k.a. CPARTICLESENCNAMEPROC
Converts string to lowercase before ID32.

;=======================================================
#label GetTScriptValue()_4 = 0x00422E50, 0x00422E30, 0x00422FD0, 0x00426F20
;=======================================================
CBaseValue GetTScriptValue(
 LPDWORDx2 lpValueNameID,	
 UNKNOWN param2,
 UNKNOWN param3,
 UINT EntryNumber
);

a.k.a. GetEntryValueProc

;=======================================================
#label GetStringID32()_3 = 0x005D9C60, 0x005A7750, 0x005DBE00, 0x005DAC50
;=======================================================
ID32 GetStringID32(
 LPSTRING lpString,
 UNKNOWN Param2,
 INT Param3
); 

a.k.a. GETTEMPINST_PROC

;=======================================================
#label GetTScriptGroupID()_5 = 0x0049C950, 0x00499DA0, 0x0049D200, 0x0049ACF0
;=======================================================
BOOL GetTScriptGroupID(
 LPDWORD lpReturnGroupNameID,  // output value
 LPDWORDx2 lpSubGroupNameIDValue,
 UNKNOWN Param3,
 UNKNOWN Param4,
 LPINT lpSubGroupCountIndex
); // returns False if group not found or true and value in lpReturnGroupNameID

a.k.a. GetGroupIDValueProc

;=======================================================
; CBaseValue
;=======================================================
sizeof.CBaseValue = 28h

#label CBaseValue::CBaseValue()_0 = 0x00491F30
#label CBaseValue::GetValue()_0 = 0x004921C0
#label CBaseValue::GetPtrToValue()_0 = 0x004922C0
#label CBaseValue::GetValueType()_0 = 0x005E3100
#label CBaseValue::GetEntryGRFNameID()_0 = 0x00491FA0

CBaseValue CBaseValue::CBaseValue(
);

DWORD CBaseValue::GetValue(
);

Does:
mov eax,[ecx+28h]
For CObjectValue, returns number of script entries
For CStringValue, returns string length

DWORD CBaseValue::GetPtrToValue(
);

Does: lea eax,[ecx+28h]

INT CBaseValue::GetValueType(
);

Does: mov eax,[ecx+4]

LPCSCRIPTGRFNAMEID CBaseValue::GetEntryGRFNameID(
);

Does: lea eax,[ecx+18h]


;=======================================================
; class CFloatValue
;=======================================================

#label CFloatValue::CFloatValue()_0 = 0x004921D0
#label CFloatValue::GetValue()_0 = 0x004921F0

FLOATFPU CFloatValue::GetValue(
); // returns in st0

Does:
fld DWORD [ecx+28h]

CFloatValue CFloatValue::CFloatValue(
);


;=======================================================
; class CBoolValue
;=======================================================

#label CBoolValue::CBoolValue()_0 = 0x00492090
#label CBoolValue::GetValue()_0 = 0x004920B0

CBoolValue CBoolValue::CBoolValue(
);

BOOL CBoolValue::GetValue(
); // returns in al

Does:
mov al,[ecx+28h]

;=======================================================
; class CCharValue
;=======================================================

#label CCharValue::CCharValue()_0 = 0x00492130

CCharValue CCharValue::CCharValue(
);

;=======================================================
; class CIntValue
;=======================================================

#label CIntValue::CIntValue()_0 = 0x004921A0

CIntValue CIntValue::CIntValue(
);

;=======================================================
; class CStringValue
;=======================================================

#label CStringValue::CStringValue()_0 = 0x00492270

CStringValue CStringValue::CStringValue(
);

CStringDesc found at (CStringValue+28h)

;=======================================================
; class CObjectValue
;=======================================================

#label CObjectValue::CObjectValue()_0 = 0x00492350
#label CObjectValue::GetEntryBaseValueIDFromIndex()_2 = 0x004923E0

CObjectValue CObjectValue::CObjectValue(
);

Value member is number of script entries this object contains.
It then contains a list of value IDs.

LPCSCRIPTBASEVALUEID CObjectValue::GetEntryBaseValueIDFromIndex(
 INT EntryIndex        // starting with 0, must be lower than CObjectValue.GetValue()
);

;=======================================================
; class CValueTable
;=======================================================

#label CValueTable::CValueTable()_0 = 0x00492670
#label CValueTable::~CValueTable()_0 = 0x004927C0
#label CValueTable::GetBaseValue()_1 = 0x004929F0

CValueTable CValueTable::CValueTable(
);

VOID CValueTable::~CValueTable(
);

CBaseValue CValueTable::GetBaseValue(
 LPCSCRIPTBASEVALUEID lpEntryBaseValueID
);

Can return CObjectValue, CBoolValue, etc.

;=======================================================
; CLocalScriptStruct (unofficial - local structure)
;=======================================================

#label CLocalScriptStruct::RegisterAllScriptNames()_0 = 0x0049F1E0
#label CLocalScriptStruct::RegisterScriptName()_2 = 0x004A10F0

VOID CLocalScriptStruct::RegisterAllScriptNames(
);

VOID CLocalScriptStruct::RegisterScriptName(
 INT EntryIndex,
 LPSTRING lpEntryName
);

;=======================================================
; class CInstSearchTable (unofficial)
;=======================================================

#label CInstSearchTable::GetInstanceFromID32() = 0x005EADC0, 0x005B8B30, 0x005ED350, 0x005ECA00

OBJECT CInstSearchTable::GetInstanceFromID32(
 ID32 InstanceID
); // a.k.a. GETOBJFROMSTRINGIDPROC


CInstSearchTable (ecx) is from:
	mov edx,[LocationADDR]
	mov ecx,[edx]

;=======================================================
; class CSimpleStruct (unofficial)
;=======================================================

#label CSimpleStruct::NullTwoDWORDS()_0 = 0x00490F50

CSimpleStruct CSimpleStruct::NullTwoDWORDS(
);

Sets two DWORDS pointed to by CSimpleStruct to null.

;=======================================================
; class CScriptGRFNameID (unofficial)
;=======================================================

#label CScriptGRFNameID::IsSameScriptName()_1 = 0x00490FA0

BOOL CScriptGRFNameID::IsSameScriptName(
 LPCSCRIPTGRFNAMEID lpOtherScriptNameID
); // returns TRUE if equal, FALSE otherwise











