macro CHECKFORFEEDCHAR reg1 { ;reg1 points to return char 0Dh
      inc reg1
      cmp BYTE [reg1],CTRL_CHAR_FEED
	  jnz @f
      inc reg1
      @@:
      }

macro FREEIFNOTNULL sourcevalue,callproc {
      mov eax,sourcevalue
      test eax,eax
	   jz @f
      invoke callproc,eax
      @@:
      }

GENERAL_PROC_ERROR			equ	FALSE
GENERAL_PROC_SUCCESS			equ	TRUE
LABEL_DEF_SIZE		equ	6		;#label
MAX_SYMBOL_SIZE 	equ	200

CTRL_CHAR_COMMENT			equ	';'
CTRL_CHAR_SPACE 			equ	' '
CTRL_CHAR_TAB				equ	09h
CTRL_CHAR_RETURN			equ	0Dh
CTRL_CHAR_FEED				equ	0Ah
CTRL_CHAR_RETURNFULL			equ	0A0Dh
CTRL_CHAR_FRONTSLASH			equ	'/'
CTRL_CHAR_BACKSLASH			equ	'\'
CTRL_CHAR_DASH				equ	'-'
CTRL_CHAR_COLON 			equ	':'
CTRL_CHAR_COMMA 			equ	','
CTRL_CHAR_EQUALITY			equ	'='

_exe_P6_1_1_Size	equ	2555904 	;EXE sizes for detection
_exe_P5_1_1_Size	equ	2580480
_exe_K6_1_1_Size	equ	2351104
_exe_P5_Demo_Size	equ	2600960

MAX_PATH		equ	260

PLUGIN_VERSION		equ	110
PM_MAIN 		equ	0
SHORTLEN		equ	8
VAL_MEMORY		equ	42
VAL_MAINBASE		equ	24
NBAR			equ	17
MM_RESTORE		equ	0x01
MM_SILENT		equ	0x02
MM_DELANAL		equ	0x04
MM_RESILENT		equ	(MM_RESTORE+MM_SILENT)
NM_LABEL		equ	0x31
NM_LIBRARY		equ	0x34

NM_NONAME		equ	0x00	     ;   // Undefined name
NM_ANYNAME		equ	0xFF	     ;   // Name of any type

NM_PLUGCMD		equ	0x30	     ;   // Plugin commands to execute at break
NM_LABEL		equ	0x31	     ;   // User-defined label
NM_EXPORT		equ	0x32	     ;   // Exported (global) name
NM_IMPORT		equ	0x33	     ;   // Imported name
NM_LIBRARY		equ	0x34	     ;   // Name from library or object file
NM_CONST		equ	0x35	     ;   // User-defined constant
NM_COMMENT		equ	0x36	     ;   // User-defined comment
NM_LIBCOMM		equ	0x37	     ;   // Comment from library or object file
NM_BREAK		equ	0x38	     ;   // Condition related with breakpoint
NM_ARG			equ	0x39	     ;   // Arguments decoded by analyzer
NM_ANALYSE		equ	0x3A	     ;   // Comment added by analyzer
NM_BREAKEXPR		equ	0x3B	     ;   // Expression related with breakpoint
NM_BREAKEXPL		equ	0x3C	     ;   // Explanation related with breakpoint
NM_ASSUME		equ	0x3D	     ;   // Assume function with known arguments
NM_STRUCT		equ	0x3E	     ;   // Code structure decoded by analyzer
NM_CASE 		equ	0x3F	     ;   // Case description decoded by analyzer

NM_INSPECT		equ	0x40	     ;   // Several last inspect expressions
NM_WATCH		equ	0x41	     ;   // Watch expressions
NM_ASM			equ	0x42	     ;   // Several last assembled strings
NM_FINDASM		equ	0x43	     ;   // Several last find assembler strings
NM_LASTWATCH		equ	0x48	     ;   // Several last watch expressions
NM_SOURCE		equ	0x49	     ;   // Several last source search strings
NM_REFTXT		equ	0x4A	     ;   // Several last ref text search strings
NM_GOTO 		equ	0x4B	     ;   // Several last expressions to follow
NM_GOTODUMP		equ	0x4C	     ;   // Several expressions to follow in Dump
NM_TRPAUSE		equ	0x4D	     ;   // Several expressions to pause trace

NM_IMCALL		equ	0xFE	     ;   // Intermodular call

;C++ type descriptor. Passed to MSVCRT.type_info.name method (returns unmangled name).
struct TypeDescriptor
       lpVTable 	dd	?
       spare		dd	?
       name		db	?	;(array of char containing mangled name)
ends

;DUMPS FROM DEMO 1.1 EXE

;constructs type_info class
;* Reference To: MSVCRT.?name@type_info@@QBEPBDXZ, Ord:0029h
;Names in TRESPASS, item 646
; Address=0064C354
; Section=.rdata
; Type=Import
; Name=MSVCRT.type_info::name

;demangles name
;* Reference To: MSVCRT.??1type_info@@UAE@XZ, Ord:000Eh
;Names in TRESPASS, item 647
; Address=0064C274
; Section=.rdata
; Type=Import
; Name=MSVCRT.type_info::~type_info

struct memsectdesc
       baseaddr 	dd	?
       size		dd	?
       endaddr		dd	?
       memname		db	SHORTLEN dup ?
			dd	0
ends

MACRO LOCALRELEASE buffer1 {
      local NoRelease
	    cmp buffer1,0
	    jz NoRelease
	       invoke LocalFree,buffer1
	       mov buffer1,0
	    NoRelease:
	}

MACRO LOCALRELEASENONULL buffer1 {
      local NoRelease
	    cmp buffer1,0
	    jz NoRelease
	       invoke LocalFree,buffer1
	    NoRelease:
	}

MACRO CMPSTRCAPPED maxlength,destifnotequal {
      local cmpstrcapped_loop,cmpstrcapped_loop_end

      mov ecx,maxlength
      cmpstrcapped_loop:  
      mov al,[esi]
      cmp al,[edi]
	  jnz destifnotequal
      test al,al
	  jz cmpstrcapped_loop_end
      inc esi
      inc edi
      dec ecx
	  jnz cmpstrcapped_loop 	      
      cmpstrcapped_loop_end:	
      }

MACRO CMPSTR destifnotequal {
      local cmpstrcapped_loop,cmpstrcapped_loop_end

      cmpstrcapped_loop:  
      mov al,[esi]
      cmp al,[edi]
	  jnz destifnotequal
      test al,al
	  jz cmpstrcapped_loop_end
      inc esi
      inc edi
      jmp cmpstrcapped_loop
      cmpstrcapped_loop_end:	
      }

MACRO CMPMEMSECTSANDSET memsectinst,incint {

;ebx = t_memory struct
;esi = destroyed
;edi = destroyed

      local cmpexit	
      cmp [memsectinst+memsectdesc.baseaddr],0
	  jnz cmpexit

      mov eax,[mainprocessbaseaddr]
      cmp [ebx+t_memory.owner],eax
	  jnz cmpexit

      lea esi,[memsectinst+memsectdesc.memname]
      lea edi,[ebx+t_memory.sect]
      CMPSTRCAPPED SHORTLEN,cmpexit
      mov eax,[ebx+t_memory.base]
      mov edx,[ebx+t_memory.size]
      mov [memsectinst+memsectdesc.baseaddr],eax
      add eax,edx
      mov [memsectinst+memsectdesc.size],edx
      mov [memsectinst+memsectdesc.endaddr],eax
 
      dec DWORD incint

      cmpexit:
	
      }


struct t_memory
       base		dd	?
       size		dd	?
       type		dd	?
       owner		dd	?
       initaccess	dd	?
       access		dd	?
       threadid 	dd	?
       sect		db	SHORTLEN dup ?
       copy		dd	?
       reserved 	dd	8 dup ?
ends

struct t_sorted
       name		db	MAX_PATH dup ?
       n		dd	?
       nmax		dd	?
       selected 	dd	?
       seladdr		dd	?
       itemsize 	dd	?
       version		dd	?
       data		dd	?
       sortfunc 	dd	?
       destfunc 	dd	?
       sort		dd	?
       sorted		dd	?
       index		dd	?
       suppresserr	dd	?
ends

struct t_table		 ;THIS STRUCTURE IS INCOMPLETE; only need up to 'data' member
       hw		dd		?
       data		t_sorted	?
ends





